package org.example;

import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicReference;

public class Main {
    AtomicReference<Thread> atomicReference = new AtomicReference<>();

    public void lock() {
        Thread threadA = Thread.currentThread();
        //假如线程A先进入锁
        System.out.printf(Thread.currentThread().getName() + "\t" + "----------come in"+"\n");
        while (!atomicReference.compareAndSet(null, threadA)) {
            //期望值为null 更新值为线程A自己
            //线程A持有锁成功
        }
    }

    public void unlock() {
        Thread threadA = Thread.currentThread();
        //线程A肯定希望出来的是自己，线程A一走锁就空了
        //使用期望值为线程A自己 更新值为null
        atomicReference.compareAndSet(threadA, null);
        System.out.printf(Thread.currentThread().getName() + "\t" + "----------task over,unlock"+"\n");


    }

    public static void main(String[] args) {
        Main main = new Main();
        new Thread(() -> {
            main.lock();
            //暂停几秒钟线程
            try {TimeUnit.SECONDS.sleep(5);} catch (InterruptedException e) {e.printStackTrace();}
            main.unlock();
        }, "A").start();
        //线程A先于线程B启动
        try {TimeUnit.MILLISECONDS.sleep(500);} catch (InterruptedException e) {e.printStackTrace();}
            new Thread(() -> {
                main.lock();
                main.unlock();
            }, "B").start();

    }
}
